﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace EFPocoCSCreater.DataBaseHelper.SQL
{
    internal class SQLHelper : IDataBase
    {
        #region 变量
        private SqlConnection _con = new SqlConnection();
        private SqlCommand _cmd = new SqlCommand();
        private SqlDataAdapter _da = new SqlDataAdapter();
        #endregion

        #region 构造
        public SQLHelper(string ip, string catalog, string user, string pass)
        {
            string conStr = string.Format("Data Source={0};Initial Catalog={1};User id={2};Password={3}", ip, catalog, user, pass);
            _con.ConnectionString = conStr;
            _cmd.Connection = _con;
            _da.SelectCommand = _cmd;
        }
        public string GetConnectionString()
        {
            return _con.ConnectionString;
        }
        #endregion

        #region 测试连接
        public bool CanOpen
        {
            get
            {
                try
                {
                    _con.Open();
                    _con.Close();
                    return true;
                }
                catch
                {
                    return false;
                }
            }
        }
        #endregion

        #region 关闭连接
        public void Close()
        {
            try
            {
                _con.Close();
            }
            catch
            {

            }
        }
        #endregion

        #region 执行语句
        public bool ExecSQL(string sql, out string mes)
        {
            _cmd.CommandText = sql;
            try
            {
                _con.Open();
                int result = _cmd.ExecuteNonQuery();
                mes = "";
                return result > 0;
            }
            catch (Exception ex)
            {
                mes = ex.Message;
                return false;
            }
            finally
            {
                _con.Close();
            }
        }
        #endregion

        #region 返回数据表
        public DataTable GetDataTable(string sql, out string mes)
        {
            _cmd.CommandText = sql;
            _da.SelectCommand = _cmd;
            DataTable dt = new DataTable();
            DataColumn dc = dt.Columns.Add("flngNO", Type.GetType("System.Int32"));
            dc.AutoIncrement = true;
            dc.AutoIncrementSeed = 1;
            dc.AutoIncrementStep = 1;
            //dc.ReadOnly = true;
            try
            {
                _con.Open();
                _da.Fill(dt);
                mes = "";
                return dt;
            }
            catch (Exception ex)
            {
                mes = ex.Message;
                return dt;
            }
            finally
            {
                _con.Close();
            }
        }

        #endregion

        #region 返回数据集
        public DataSet GetDataSet(string sql, out string mes)
        {
            DataSet ds = new DataSet();
            try
            {
                ds.Tables.Add(GetDataTable(sql, out mes));
                return ds;
            }
            catch (Exception ex)
            {
                mes = ex.Message;
                return null;
            }
        }


        #endregion

        #region 返回数据条数
        public int GetCount(string sql, out string mes)
        {
            DataTable dt = GetDataTable(sql, out mes);
            try
            {
                return dt.Rows.Count;
            }
            catch (Exception ex)
            {
                mes = ex.Message;
                return 0;
            }
        }

        #endregion

        #region 返回第一个值
        public string GetFirstString(string sql, out string mes)
        {
            string tmp;
            DataTable dt = GetDataTable(sql, out mes);
            if (dt == null || dt.Rows.Count < 1 || dt.Columns.Count < 1)
                return null;
            try
            {
                tmp = dt.Rows[0][1].ToString();
            }
            catch
            {
                tmp = "读取数据错误";
            }
            return tmp;
        }

        #endregion

    }
}
